#include <opencv2/opencv.hpp>
#include <opencv2/features2d/features2d.hpp>
#include <opencv2/xfeatures2d.hpp>


#include <iostream>

using namespace cv;
using namespace std;

int main(int argc, char *argv[]) {
    
    
    Mat src = imread("church01.jpg", 0);
    Mat proc = imread("church01.jpg", 0);
    Mat drawImg;
    
    Ptr<Feature2D> f2d = xfeatures2d::SIFT::create();
    
    std::vector<KeyPoint> keypoints_1, keypoints_2;    
    f2d->detect( src, keypoints_1 );
    f2d->detect( proc, keypoints_2 );

    
    Mat descriptors_1, descriptors_2;    
    f2d->compute( src, keypoints_1, descriptors_1 );
    f2d->compute( proc, keypoints_2, descriptors_2 );

    
    BFMatcher matcher(NORM_L2);
    std::vector< DMatch > matches;
    matcher.match( descriptors_1, descriptors_2, matches );

    drawMatches( src, keypoints_1, proc, keypoints_2, matches, drawImg);
    
    imshow("Resultado", drawImg );
    waitKey(0);
}