#include <opencv2/opencv.hpp>
#include <opencv2/features2d/features2d.hpp>
#include <opencv2/xfeatures2d.hpp>


#include <iostream>

using namespace cv;
using namespace std;

int main(int argc, char *argv[]) {
    
    
    Mat src = imread("church01.jpg", 0);
    Mat proc = imread("church01.jpg", 0);
    Mat drawImg;
    
    Ptr<SURF> detector = SURF::create();
    detector->setHessianThreshold(400);
    
    vector<KeyPoint> keypoints_1, keypoints_2; 
    Mat descriptors_1, descriptors_2;    
    
    detector->detectAndCompute( src,  Mat(), keypoints_1, descriptors_1 );
    detector->detectAndCompute( proc, Mat(), keypoints_2, descriptors_2 );   
        
    BFMatcher matcher(NORM_L2);
    std::vector< DMatch > matches;
    matcher.match( descriptors_1, descriptors_2, matches );

    drawMatches( src, keypoints_1, proc, keypoints_2, matches, drawImg);
    
    imshow("Resultado", drawImg );
    waitKey(0);
}