#include "opencv2/opencv.hpp"

#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace cv;
using namespace std;

int main( int argc, char** argv )
{
    Mat img, src, dst;
    img = imread("church01.jpg");
    
    cvtColor(img, src, CV_BGR2GRAY);
    
    //obtem cantos
    cornerHarris( src, dst, 3, 
                            3, 
                            0.04
                );
    
    //supressão dos mínimos
    //dilata para aumentar cantos
    //depois obtem o máximo
    //e corta um fator (0.01) em relação ao máximo (para deixar somente extremos)
    dilate(dst,dst,cv::Mat());
    double minStrength, maxStrength;
    minMaxLoc(dst,&minStrength,&maxStrength);
    
    for( int j = 0; j < img.rows ; j++ )
        for( int i = 0; i < img.cols; i++ )
            if (dst.at<float>(j,i) > 0.01*maxStrength)
                src.at<uchar>(j,i) = 255;

    imshow("Resultado", src);
    waitKey(0);
    
    
    return(0);
}

